diff -Ncr linux-2.4.20-aralion-0.0/drivers/scsi/ultimaraid133/ultima.c linux-2.4.20-aralion-0.1/drivers/scsi/ultimaraid133/ultima.c
*** linux-2.4.20-aralion-0.0/drivers/scsi/ultimaraid133/ultima.c	1970-01-01 09:00:00.000000000 +0900
--- linux-2.4.20-aralion-0.1/drivers/scsi/ultimaraid133/ultima.c	2003-11-26 16:30:31.000000000 +0900
***************
*** 0 ****
--- 1,1931 ----
+ /*******************************************************************
+ 
+   Aralion Ultima ATA133 IDE Raid Controller
+   Linux Device Driver source, programmed by soonsoo@hitel.net
+ 
+  *******************************************************************/
+ //#define  __BOOT_KERNEL_BOOT	1
+ 
+ //#define	DEBUG1	1
+ //#define	DEBUG2	1
+ //#define	DEBUG3	1
+ //#define	DEBUG4	1
+ 
+ #include <linux/version.h>
+ #include <linux/module.h>
+ #include <linux/stddef.h>
+ #include <linux/string.h>
+ #include <linux/sched.h>
+ #include <linux/kernel.h>
+ #include <linux/ioport.h>
+ #include <linux/delay.h>
+ #include <linux/proc_fs.h>
+ #include <linux/spinlock.h>
+ #include <asm/io.h>
+ #include <asm/bitops.h>
+ #include <asm/system.h>
+ #include <asm/dma.h>
+ #include <linux/blk.h>
+ #include "../scsi.h"
+ #include "../hosts.h"
+ #include "../sd.h"
+ #include "ultima.h"
+ #include "atapi.h"
+ #include <linux/errno.h>
+ #include <linux/pci.h>
+ #include <linux/stat.h>
+ #include <linux/config.h>	/* for CONFIG_PCI */
+ #include <linux/fs.h>
+ #include <asm/segment.h> /* for put_user_byte */
+ #include <asm/uaccess.h>
+ #include <asm/atomic.h>
+ #include "iocontrol.h"
+ #include "flash.h"
+ 
+ #if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,0)
+ #define KERNEL240
+ #else
+ #define KERNEL220
+ #endif
+ 
+ #define S_BOARD(x,y) (DiskID[x].DiskStatus.BoardID)
+ #define S_CHAN(x,y) (DiskID[x].DiskStatus.Channel)
+ #define S_DRV(x,y) (DiskID[x].DiskStatus.Drive)
+ #define RAID(x) (DiskID[x].RaidStatus)
+ #define DEG	printk("<1> "__FUNCTION__": %d\n",__LINE__)
+ ////////////////////////////////////////////////////////////////////////////////
+ 
+ static void     print_banner(struct Scsi_Host *shpnt);
+ char * 		GetCmdName(char code);
+ static void    print_banner(struct Scsi_Host *shpnt);
+ static void    do_pause(ULONG amount);
+ static int     aralion_pci_bios_detect(int *irq);
+ ULONG			GetBlockCount(int BoardID,int channel,int drive);
+ int			RequestAllIrq(void);
+ void 			PutLBAvalue(ULONG IOPort1,
+ 		ULONG lba,
+ 		ULONG numsectors,
+ 		ULONG DriveSelect);
+ void			DisableInterrupt(int BoardID);
+ void			EnableInterrupt(int BoardID);
+ ULONG			SetBoardInterruptFlag(int BoardID,int Channel,DWORD Status);
+ ULONG 			SetScatterList(Scsi_Cmnd *SCpnt,
+ 		ULONG lba,
+ 		ULONG numsectors,
+ 		ULONG ReadWrite);
+ void 			SetIOPort(DISKLIST *pList,USHORT DmaRW,DWORD OrderFlag);
+ void 			SetIOInformation(int tid,USHORT DmaRW,DWORD OrderFlag);
+ ULONG 			PutOneScatterList(ULONG	CurrentID,
+ 		DWORD PrimaryDiskArrayCount,
+ 		DISKLIST *PrimaryDiskArray,
+ 		ULONG lba,
+ 		ULONG buffer,
+ 		USHORT length);
+ void			SetIDECommand(DWORD Command, DWORD order);
+ DWORD			BigDiskCommand (DWORD cmnd);
+ void			SetDMACommand(USHORT DmaRW,DWORD OrderFlag);
+ static int		ReadDMA(Scsi_Cmnd * SCpnt,
+ 		ULONG lba,
+ 		ULONG numsectors);
+ static int		WriteDMA(Scsi_Cmnd * SCpnt,
+ 		ULONG lba,
+ 		ULONG numsectors);
+ void		GetUDMAMode(USHORT *mode,
+ 		USHORT *Timing,
+ 		IDENTIFY_DATA * IdentifyData);
+ void		SetUDMAMode(int BoardID, int Channel, int Drive);
+ static int	IdentifyDisk(int BoardID,
+ 		int Channel, 
+ 		int DriveSelect, 
+ 		IDENTIFY_DATA * IdentifyData);
+ static void		my_done(int error);
+ int				CheckScsiError(ULONG Channel,ULONG IOPort1,UCHAR statusByte);
+ void			CheckJobFinished(ULONG BoardID,ULONG Channel);
+ int 			IsSplitter(char c);
+ int            	ultima_1cardreset(int BoardID);
+ int            	ultima_cardreset(void);
+ void 			do_ultima_intr(int irq, void *dev_id, struct pt_regs *regs);
+ void			internal_done(Scsi_Cmnd * SCpnt);
+ void          	print_info(Scsi_Cmnd * SCpnt);
+ 
+ ////////////////////////////////////////////////////////////////////////////////
+ 
+ struct proc_dir_entry proc_scsi_aralion = {
+ 	0x10, 7, "aralion",
+ 	S_IFDIR | S_IRUGO | S_IXUGO, 2
+ };
+ 
+ Scsi_Host_Template driver_template = ULTIMA_DMA133;
+ 
+ #define VERSION          "$Revision: LH 1.11BCS $"
+ 
+ enum {
+ 	in_arbitration = 0x02,
+ 	in_selection = 0x04,
+ 	in_other = 0x08,
+ 	disconnect = 0x10,
+ 	aborted = 0x20,
+ 	sent_ident = 0x40,
+ };
+ 
+ typedef struct {
+ 	char name[23];
+ 	char code;
+ } CMDNAME;
+ 
+ CMDNAME CmdName[] =
+ {
+ 	{"TEST_UNIT_READY",0x00},
+ 	{"REZERO_UNIT",0x01},
+ 	{"REQUEST_SENSE",0x03},
+ 	{"FORMAT_UNIT",0x04},
+ 	{"READ_BLOCK_LIMITS",0x05},
+ 	{"REASSIGN_BLOCKS",0x07},
+ 	{"READ_6",0x08},
+ 	{"WRITE_6",0x0a},
+ 	{"SEEK_6",0x0b},
+ 	{"READ_REVERSE",0x0f},
+ 	{"WRITE_FILEMARKS",0x10},
+ 	{"SPACE",0x11},
+ 	{"INQUIRY",0x12},
+ 	{"RECOVER_BUFFERED_DATA",0x14},
+ 	{"MODE_SELECT",0x15},
+ 	{"RESERVE",0x16},
+ 	{"RELEASE",0x17},
+ 	{"COPY",0x18},
+ 	{"ERASE",0x19},
+ 	{"MODE_SENSE",0x1a},
+ 	{"START_STOP",0x1b},
+ 	{"RECEIVE_DIAGNOSTIC",0x1c},
+ 	{"SEND_DIAGNOSTIC",0x1d},
+ 	{"ALLOW_MEDIUM_REMOVAL",0x1e},
+ 	{"SET_WINDOW",0x24},
+ 	{"READ_CAPACITY",0x25},
+ 	{"READ_10",0x28},
+ 	{"WRITE_10",0x2a},
+ 	{"SEEK_10",0x2b},
+ 	{"WRITE_VERIFY",0x2e},
+ 	{"VERIFY",0x2f},
+ 	{"SEARCH_HIGH",0x30},
+ 	{"SEARCH_EQUAL",0x31},
+ 	{"SEARCH_LOW",0x32},
+ 	{"SET_LIMITS",0x33},
+ 	{"PRE_FETCH",0x34},
+ 	{"READ_POSITION",0x34},
+ 	{"SYNCHRONIZE_CACHE",0x35},
+ 	{"LOCK_UNLOCK_CACHE",0x36},
+ 	{"READ_DEFECT_DATA",0x37},
+ 	{"MEDIUM_SCAN",0x38},
+ 	{"COMPARE",0x39},
+ 	{"COPY_VERIFY",0x3a},
+ 	{"WRITE_BUFFER",0x3b},
+ 	{"READ_BUFFER",0x3c},
+ 	{"UPDATE_BLOCK",0x3d},
+ 	{"READ_LONG",0x3e},
+ 	{"WRITE_LONG",0x3f},
+ 	{"CHANGE_DEFINITION",0x40},
+ 	{"WRITE_SAME",0x41},
+ 	{"READ_TOC",0x43},
+ 	{"LOG_SELECT",0x4c},
+ 	{"LOG_SENSE",0x4d},
+ 	{"MODE_SELECT_10",0x55},
+ 	{"RESERVE_10",0x56},
+ 	{"RELEASE_10",0x57},
+ 	{"MODE_SENSE_10",0x5a},
+ 	{"PERSISTENT_RESERVE_IN",0x5e},
+ 	{"PERSISTENT_RESERVE_OUT",0x5f},
+ 	{"MOVE_MEDIUM",0xa5},
+ 	{"READ_12",0xa8},
+ 	{"WRITE_12",0xaa},
+ 	{"WRITE_VERIFY_12",0xae},
+ 	{"SEARCH_HIGH_12",0xb0},
+ 	{"SEARCH_EQUAL_12",0xb1},
+ 	{"SEARCH_LOW_12",0xb2},
+ 	{"READ_ELEMENT_STATUS",0xb8},
+ 	{"SEND_VOLUME_TAG",0xb6},
+ 	{"WRITE_LONG_2",0xea}
+ };
+ 
+ ////////////////////////////////////////////////////////////////////////////////
+ static volatile int 		internal_done_flag = 0;
+ static volatile int 		internal_done_errcode = 0;
+ static Scsi_Cmnd 			*current_SC = NULL;
+ static int      			this_id = 31;
+ V6INTERFACEB 				V6;
+ static _DiskIDTable			DiskID[16];
+ static DISKRWINFO			DiskRWInfo[MAXBOARD][2][2];
+ static IDENTIFY_DATA 		DiskIdentifyData[MAXBOARD][2][2];
+ static int					gBoardCount = 0;
+ IrqID						ultimaID[MAXBOARD];
+ BOARDTABLE					BoardInfo[MAXBOARD];
+ static int					IrqFlag[32] = {0,};
+ static int					DiskCount = 0;
+ ULONG						LastErrorBlock,LastErrorCode;
+ static ULONG				RWStatus;
+ static ULONG				OrderStatus;
+ static ULONG				CurrentDisk;
+ static int      			interrupt_level = 0;
+ static int					HddConnected[MAXBOARD][2][2];
+ static int					HddSupportMode[MAXBOARD][2][2];
+ 
+ /////////////////////////////////////////////////
+ #define IOCTL_LOCK	1
+ static int 					in_ioctl = 0;
+ static int 					in_command = 0;
+ unsigned long 				LockValue = 0;
+ static DECLARE_WAIT_QUEUE_HEAD (WaitingQ);
+ 
+ /////////////////////////////////////////////////
+ UCHAR 						BiosManufacture = 0;
+ UCHAR						cDeviceCode = 0;
+ UCHAR   					cFlashFlag = 0;
+ UCHAR						*Buffer;
+ char *GetCmdName(char code)
+ {
+ 	int i;
+ 	int count;
+ 	char *s = "unknown function";
+ 
+ 	count = sizeof(CmdName) / sizeof(CMDNAME);
+ 
+ 	for(i=0;i<count;i++) {
+ 		if (CmdName[i].code == code)
+ 			return CmdName[i].name;
+ 	}
+ 	return s;
+ }
+ 
+ static void		print_banner(struct Scsi_Host *shpnt)
+ {
+ 	if (!shpnt)
+ 		return;			/* This won't ever happen */
+ 
+ 	printk("using scsi id %d\n", shpnt->this_id);
+ 
+ 	if (interrupt_level)
+ 		printk(" int %d", interrupt_level);
+ 	else
+ 		printk("<none>");
+ 
+ 	printk("\n");
+ }
+ 
+ static void		aralion_setup(char *str, int *ints)
+ {
+ 	this_id = 31;
+ }
+ 
+ 
+ /* Pause for amount*10 milliseconds */
+ static void		do_pause(ULONG amount)
+ {
+ 	do
+ 	{
+ 		udelay(10 * 1000);
+ 	}
+ 	while (--amount);
+ }
+ 
+ inline static void aralion_make_bus_idle(void)
+ {
+ }
+ 
+ static int      aralion_is_valid_port(int port)
+ {
+ 	return 0;
+ }
+ 
+ static int      aralion_test_loopback(void)
+ {
+ 	return 0;
+ }
+ 
+ static int      aralion_pci_bios_detect(int *irq)
+ {
+ 	struct pci_dev *pdev = NULL;
+ 
+ 	if (!pci_present())
+ 		return 0;
+ 
+ 	memset(BoardInfo,0,sizeof(BoardInfo));
+ 
+ 	do {
+ 		if ((pdev = pci_find_device(ARALION_VENDOR, ULTIMA_DEVICE, pdev)) != NULL) {
+ 			//			printk("Find %d device\n",gBoardCount);
+ 			//			BoardInfo[gBoardCount].BoardExist = 1;
+ 
+ #ifdef KERNEL240
+ 			BoardInfo[gBoardCount].PrimaryIO 
+ 				= (ULONG) pci_resource_start(pdev,0);
+ 			BoardInfo[gBoardCount].SecondaryIO 
+ 				= (ULONG) (BoardInfo[gBoardCount].PrimaryIO)+0x10; 
+ 			BoardInfo[gBoardCount].PrimaryDmaIO 
+ 				= (ULONG) (BoardInfo[gBoardCount].PrimaryIO)+0x20; 
+ 			BoardInfo[gBoardCount].SecondaryDmaIO 
+ 				= (ULONG) (BoardInfo[gBoardCount].PrimaryIO)+0x30; 
+ 			BoardInfo[gBoardCount].ControlRegister 
+ 				= (ULONG) (BoardInfo[gBoardCount].PrimaryIO)+0x40; 
+ 			BoardInfo[gBoardCount].FlashMemory
+ 				= (ULONG) (BoardInfo[gBoardCount].PrimaryIO)+0x50; 
+ #else
+ 			BoardInfo[gBoardCount].PrimaryIO 
+ 				= (ULONG) pdev->base_address[0] & PCI_BASE_SDDRESS_IO_MASK;
+ 			BoardInfo[gBoardCount].SecondaryIO 
+ 				= (ULONG) (BoardInfo[gBoardCount].PrimaryIO)+0x10; 
+ 			BoardInfo[gBoardCount].PrimaryDmaIO 
+ 				= (ULONG) (BoardInfo[gBoardCount].PrimaryIO)+0x20; 
+ 			BoardInfo[gBoardCount].SecondaryDmaIO 
+ 				= (ULONG) (BoardInfo[gBoardCount].PrimaryIO)+0x30; 
+ 			BoardInfo[gBoardCount].ControlRegister 
+ 				= (ULONG) (BoardInfo[gBoardCount].PrimaryIO)+0x40; 
+ 			BoardInfo[gBoardCount].FlashMemory
+ 				= (ULONG) (BoardInfo[gBoardCount].PrimaryIO)+0x50; 
+ #endif
+ 
+ 			BoardInfo[gBoardCount].interrupt_level = pdev->irq;
+ 
+ 			request_region(BoardInfo[gBoardCount].PrimaryIO, 0x10, "aralion");
+ 			request_region(BoardInfo[gBoardCount].SecondaryIO, 0x10, "aralion");
+ 			request_region(BoardInfo[gBoardCount].PrimaryDmaIO, 0x10, "aralion");
+ 			request_region(BoardInfo[gBoardCount].SecondaryDmaIO, 0x10, "aralion");
+ 			request_region(BoardInfo[gBoardCount].ControlRegister, 0x10, "aralion");
+ 			request_region(BoardInfo[gBoardCount].FlashMemory,0x8, "aralion");
+ 
+ 			if (!gBoardCount)
+ 				*irq = pdev->irq;
+ 
+ 			gBoardCount++;
+ 		}
+ 	} while(pdev != NULL);
+ 
+ 
+ 	if (!gBoardCount) {
+ 		printk("Ultima Board not found\n");
+ 		return 0;
+ 	}
+ 
+ 	interrupt_level = BoardInfo[0].interrupt_level;
+ 	return 1;
+ }
+ 
+ ULONG	GetBlockCount(int BoardID,int channel,int drive)
+ {
+ 	int i;
+ 	ULONG nCount;
+ 	UCHAR *p;
+ 	p = (char *) &(DiskIdentifyData[BoardID][channel][drive]);
+ 	if(DiskIdentifyData[BoardID][channel][drive].BIT48 & 0x0400)
+ 		nCount = *((ULONG *) (p + 200));
+ 	else
+ 		nCount = *((ULONG *) (p + 120));
+ 	return nCount;
+ }
+ 
+ int	RequestAllIrq(void) 
+ {
+ 	int			i;
+ 	int			irq;
+ 	int			retcode;
+ 
+ 	for(i=0;i<gBoardCount;i++) {
+ 		irq = BoardInfo[i].interrupt_level;
+ 
+ 		if (!IrqFlag[irq]) {
+ 			IrqFlag[irq] = 1;
+ 			memset(ultimaID[i].signature,0,8);
+ 			memcpy(ultimaID[i].signature,"Ultima",6);
+ 			ultimaID[i].IOPort1 = BoardInfo[i].PrimaryDmaIO;
+ 			ultimaID[i].irq = irq;
+ 
+ 			retcode = request_irq(irq,
+ 					do_ultima_intr, 
+ 					SA_INTERRUPT | SA_SHIRQ, 
+ 					"aralion", 
+ 					&ultimaID[i]);
+ 			if (retcode < 0)
+ 			{
+ 				printk("%d's Board IRQ Failure\n",i);
+ 
+ 				if (retcode == -EINVAL)	{
+ 					printk("scsi: <aralion> IRQ %d is bad!\n", irq);
+ 					printk("                This shouldn't happen!\n");
+ 					printk("                Send mail to faith@acm.org\n");
+ 				}
+ 				else if (retcode == -EBUSY) {
+ 					printk("scsi: <aralion> IRQ %d is already in use!\n",irq);
+ 					printk("                Please use another IRQ!\n");
+ 				}
+ 				else {
+ 					printk("scsi: <aralion> Error getting IRQ %d\n",irq);
+ 					printk("                This shouldn't happen!\n");
+ 					printk("                Send mail to faith@acm.org\n");
+ 				}
+ 				printk("scsi: <aralion> Detected, but driver not loaded (IRQ)\n");
+ 
+ 				return retcode;
+ 			}
+ 		}
+ 	}
+ 	return 0;
+ }
+ 
+ int             ultima_detect(Scsi_Host_Template * tpnt)
+ {
+ 	int             retcode;
+ 	struct Scsi_Host *shpnt;
+ 	int             i, j, statusByte;
+ 	int             flag = 0;
+ 	ULONG			IOPort;
+ 
+ 	tpnt->proc_dir = &proc_scsi_aralion;
+ 	flag = aralion_pci_bios_detect(&interrupt_level);
+ 
+ 	if (!flag) {
+ 		printk("scsi: Ultima not found\n");
+ 		return 0;
+ 	}
+ 
+ 	memset(&DiskID,0,sizeof(DiskID));
+ 	memset(&DiskRWInfo,0,sizeof(DiskRWInfo));
+ 	memset(&DiskIdentifyData,0,sizeof(DiskIdentifyData));
+ 	DiskCount = 0;
+ 
+ 	for(i=0;i<gBoardCount;i++)
+ 	{
+ 		DisableInterrupt(i);
+ 		ultima_1cardreset(i);
+ 		EnableInterrupt(i);
+ 	}
+ 
+ 	for(i=0;i<gBoardCount;i++)
+ 	{
+ 		IOPort = BoardInfo[i].PrimaryIO;
+ 		
+ 		SelectFirstChannel(i);
+ 		outb(0xA0 ,IOPort + DriveSelectPort);
+ 		GetBaseStatus(IOPort, statusByte);
+ 		if(statusByte == 0x50)
+ 			HddConnected[i][0][0] = 1;
+ 		else
+ 			HddConnected[i][0][0] = 0;
+ 			
+ 		outb(0xB0 ,IOPort + DriveSelectPort);
+ 		GetBaseStatus(IOPort, statusByte);
+ 		if(statusByte == 0x50)
+ 			HddConnected[i][0][1] = 1;
+ 		else
+ 			HddConnected[i][0][1] = 0;
+ 		
+ 		SelectSecondChannel(i);
+ 		outb(0xA0 ,IOPort + DriveSelectPort);
+ 		GetBaseStatus(IOPort, statusByte);
+ 		if(statusByte == 0x50)
+ 			HddConnected[i][1][0] = 1;
+ 		else
+ 			HddConnected[i][1][0] = 0;
+ 		outb(0xB0 ,IOPort + DriveSelectPort);
+ 		GetBaseStatus(IOPort, statusByte);
+ 		if(statusByte == 0x50)
+ 			HddConnected[i][1][1] = 1;
+ 		else
+ 			HddConnected[i][1][1] = 0;
+ 	}
+ /*	
+ 	for(j=0;j<4;j++)
+ 		printk("HDD:[%d]=%d\n",j,HddConnected[0][j/2][j%2]);
+ */
+ 	for(i=0;i<gBoardCount;i++)
+ 	{
+ 		DisableInterrupt(i);
+ 		for(j=0;j<4;j++)
+ 		{
+ 			if(HddConnected[i][j/2][j%2])
+ 			{	
+ 				IdentifyDisk(i,j/2,j%2,&DiskIdentifyData[i][j/2][j%2]);
+ 				SetUDMAMode(i,j/2,j%2);
+ 				DiskID[DiskCount].DiskStatus.BoardID = i;
+ 				DiskID[DiskCount].DiskStatus.Channel = j/2;
+ 				DiskID[DiskCount].DiskStatus.Drive = j%2;
+ 				DiskID[DiskCount].RaidStatus = NORMALIDE;
+ 				DiskID[DiskCount].DiskStatus.Size = GetBlockCount(i,j/2,j%2);
+ 				DiskCount++;
+ 			}
+ 		}
+ 		EnableInterrupt(i);
+ 	}
+ 
+ 
+ 	tpnt->this_id = (this_id & 0x1f);
+ 
+ 	/* Print out a banner here in case we can't
+ 	   get resources.  */
+ 	shpnt = scsi_register(tpnt, 0);
+ 	shpnt->irq = interrupt_level;
+ 	shpnt->io_port = BoardInfo[0].ControlRegister;
+ 	shpnt->n_io_port = 0x10;
+ 	//    print_banner(shpnt);
+ 
+ 	if (!interrupt_level)
+ 	{
+ 		printk("scsi: <aralion>"
+ 				" Card Detected, but driver not loaded (no IRQ)\n");
+ 		return 0;
+ 	}
+ 	else
+ 	{
+ 		/* Register the IRQ with the kernel */
+ 		if (RequestAllIrq())
+ 			return 0;
+ 	}
+ 
+ 	for(i=0;i<gBoardCount;i++) {
+ 		BoardInfo[i].PriScatterList = kmalloc(SCATTERLISTSIZE,GFP_ATOMIC);
+ 		BoardInfo[i].SecScatterList = kmalloc(SCATTERLISTSIZE,GFP_ATOMIC);
+ 	}			
+ 	return 1;
+ }
+ 
+ 
+ int             ultima_release(struct Scsi_Host * tpnt)
+ {
+ 	int		i;
+ 	int		irq;
+ 
+ 	for(i=0;i<gBoardCount;i++) {
+ 		irq = BoardInfo[i].interrupt_level;
+ 		if (IrqFlag[irq]) {
+ 			free_irq(irq,&ultimaID[i]);
+ 			IrqFlag[irq] = 0;
+ 		}
+ 		release_region(BoardInfo[i].PrimaryIO,0x10);
+ 		release_region(BoardInfo[i].SecondaryIO,0x10);
+ 		release_region(BoardInfo[i].PrimaryDmaIO,0x10);
+ 		release_region(BoardInfo[i].SecondaryDmaIO,0x10);
+ 		release_region(BoardInfo[i].ControlRegister,0x10);
+ 		release_region(BoardInfo[i].FlashMemory,0x8);
+ 
+ 		kfree(BoardInfo[i].PriScatterList);
+ 		kfree(BoardInfo[i].SecScatterList);
+ 	}
+ 	scsi_unregister(tpnt);
+ 
+ 	return 0;
+ }
+ 
+ #ifdef DEBUG
+ void printDMARegister(int BoardID)
+ {
+ 	int i;
+ 	USHORT d1;
+ 
+ 	for(i=0;i<0x10;i++) {
+ 		d1 = inw(BoardInfo[BoardID].ControlRegister + i*2);
+ 		printk("<%02x:%04x> ",i,d1);
+ 	}
+ 	printk("\n");
+ }
+ #endif
+ 
+ inline DISKRWINFO *GetRWInfoPointer(DISKLIST *pDiskList)
+ {
+ 	return (DISKRWINFO *) &DiskRWInfo[pDiskList->BoardID][pDiskList->Channel][pDiskList->Drive];
+ }
+ 
+ void PutLBAvalue(ULONG IOPort1,ULONG lba,ULONG numsectors,
+ 		ULONG DriveSelect)
+ {
+ 	UCHAR	Data[4];
+ 	/////////////////////////////KHG-133s_Big////////////////////////////////	
+ 	if(lba >= 0x10000000){
+ 		Data[0] = (lba & 0xff000000 ) >> 24;
+ 		Data[1] = 0;
+ 		Data[2] = 0;
+ 		outb(0,IOPort1 + BlockCountPort);
+ 		outb(Data[0],IOPort1 + BlockNumberPort);
+ 		outb(Data[1],IOPort1 + CylinderLowPort);
+ 		outb(Data[2],IOPort1 + CylinderHighPort);
+ 		Data[0] = (lba & 0x000000ff);
+ 		Data[1] = (lba & 0x0000ff00) >> 8;
+ 		Data[2] = (lba & 0x00ff0000) >> 16;
+ 		Data[3] = (DriveSelect << 4) | 0xe0;
+ 		outb(numsectors,IOPort1 + BlockCountPort);
+ 		outb(Data[0],IOPort1 + BlockNumberPort);
+ 		outb(Data[1],IOPort1 + CylinderLowPort);
+ 		outb(Data[2],IOPort1 + CylinderHighPort);
+ 		outb(Data[3],IOPort1 + DriveSelectPort);
+ 	}
+ 	else{
+ 		Data[0] = (lba & 0x000000ff);
+ 		Data[1] = (lba & 0x0000ff00) >> 8;
+ 		Data[2] = (lba & 0x00ff0000) >> 16;
+ 		Data[3] = (lba & 0x0f000000) >> 24;
+ 		Data[3] = Data[3] | 0x40 | (DriveSelect << 4) | 0xa0;
+ 
+ 		outb(numsectors,IOPort1 + BlockCountPort);
+ 		outb(Data[0],IOPort1 + BlockNumberPort);
+ 		outb(Data[1],IOPort1 + CylinderLowPort);
+ 		outb(Data[2],IOPort1 + CylinderHighPort);
+ 		outb(Data[3],IOPort1 + DriveSelectPort);
+ 	}
+ 	/////////////////////////////////////////////////////////////////////////
+ }
+ 
+ void DisableInterrupt(int BoardID)
+ {
+ 	USHORT		Intena;
+ 
+ 	//	Intena = inw(BoardInfo[BoardID].ControlRegister + INTENA);
+ 	//	Intena = Intena & 0xfe;
+ 	Intena = 0;
+ 	outw(Intena,BoardInfo[BoardID].ControlRegister + INTENA);
+ }
+ 
+ void EnableInterrupt(int BoardID)
+ {
+ 	USHORT		Intena;
+ 
+ 	//	Intena = inw(BoardInfo[BoardID].ControlRegister + INTENA);
+ 	//	Intena = Intena | 0x01;
+ 	Intena = 0x03;		//KHG
+ 
+ 	//	printk("EI : %d\n",BoardID);
+ 	outw(Intena,BoardInfo[BoardID].ControlRegister + INTENA);
+ 	//	printk("EI2 : %d\n",BoardID);
+ }
+ 
+ // int SetBoardInterruptFlag(int BoardID,int Channel,DWORD Status)
+ ULONG SetBoardInterruptFlag(int BoardID,int Channel,DWORD Status)
+ {
+ 	////////////////////////////////////KHG-133s////////////////////////////////////
+ 	ULONG	TempStatus;
+ 	Channel = 0;
+ 
+ 	if (BoardInfo[BoardID].InterruptFlag[Channel] & Status) {
+ 		TempStatus = BoardInfo[BoardID].InterruptFlag[Channel] & 0x00001111;
+ 		if(TempStatus & 0x00001100){
+ 			BoardInfo[BoardID].InterruptFlag[Channel] |= 0x00001000;
+ 			return 0x00001000;
+ 		}
+ 		else if(TempStatus & 0x00000010){
+ 			BoardInfo[BoardID].InterruptFlag[Channel] |= 0x00000100;
+ 			return 0x00000100;
+ 		}
+ 		else {
+ 			BoardInfo[BoardID].InterruptFlag[Channel] |= 0x00000010;
+ 			return 0x000000010;
+ 		}
+ 	}
+ 	else {
+ 		BoardInfo[BoardID].InterruptFlag[Channel] = (Status | ORDER_ONE);
+ 		return 0;
+ 	}
+ }
+ 
+ ULONG SetScatterList(	Scsi_Cmnd * SCpnt,
+ 		ULONG lba,
+ 		ULONG numsectors,
+ 		ULONG	ReadWrite)
+ {
+ 	struct scatterlist 	*slp;
+ 	int					i,j;
+ 	PPDT_TABLE 			pPDTTable;
+ 	DISKRWINFO			*pRWInfo,*pRWInfo2;
+ 	int					tid = SCpnt->target;
+ 	DWORD				RaidStatus;
+ 	ULONG	TempFlag;
+ 
+ 	RaidStatus = RAID(tid);
+ 
+ 	pRWInfo = (DISKRWINFO *) &DiskRWInfo[S_BOARD(tid,0)][S_CHAN(tid,0)][S_DRV(tid,0)];
+ 
+ 	pRWInfo->StartLba = lba;
+ 	pRWInfo->ListCount = 0;
+ 	pRWInfo->NumSectors = 0;
+ 	pPDTTable = pRWInfo->ScatterList;
+ 	if (SCpnt->use_sg) {
+ 		slp = (struct scatterlist *) SCpnt->request_buffer;
+ 		for(i=0;i<SCpnt->use_sg;i++,slp++) {
+ 			pPDTTable[i].address = virt_to_bus(slp->address);
+ 			pPDTTable[i].length = slp->length;
+ 			pPDTTable[i].EndOfChain = 0;
+ 			pRWInfo->NumSectors += slp->length;
+ 		}
+ 		pPDTTable[i - 1].EndOfChain = 0x80;
+ 		pRWInfo->ListCount = SCpnt->use_sg;
+ 	}
+ 	else {
+ 		pPDTTable[0].address = virt_to_bus(SCpnt->request_buffer);
+ 		pPDTTable[0].length = SCpnt->request_bufflen;
+ 		pPDTTable[0].EndOfChain = 0x80;
+ 		pRWInfo->NumSectors = SCpnt->request_bufflen;
+ 		pRWInfo->ListCount = 1;
+ 	}
+ 
+ 	pRWInfo->NumSectors /= 512;
+ 
+ 	pRWInfo->InterruptFlag = ReadWrite | ORDER_ONE;
+ 	SetBoardInterruptFlag(S_BOARD(tid,0),S_CHAN(tid,0),ReadWrite);
+ }
+ 
+ void PrintPDT(PPDT_TABLE  pPDTTable,int count)
+ {
+ 	int i;
+ 
+ 	for(i=0;i<count;i++) {
+ 		printk("%04d : [%08x,%04x,%02x]\n",i,
+ 				pPDTTable[i].address,
+ 				pPDTTable[i].length,
+ 				pPDTTable[i].EndOfChain);
+ 	}	
+ }
+ 
+ void SetIOPort(DISKLIST *pList,USHORT DmaRW,DWORD OrderFlag)
+ {
+ 	USHORT		AddressLow,AddressHi;
+ 	PPDT_TABLE  pPDTTable;
+ 	long		i;
+ 	DISKRWINFO	*pRWInfo;
+ 	ULONG		BoardID,Channel,Drive;
+ 	ULONG		IOPort1,DmaIO;
+ 
+ 	BoardID = pList->BoardID;
+ 	Channel = pList->Channel;
+ 	Drive = pList->Drive;
+ 
+ 	pRWInfo = (DISKRWINFO *) &DiskRWInfo[pList->BoardID][pList->Channel][pList->Drive];
+ 	if (!(OrderFlag & pRWInfo->InterruptFlag)) {
+ 		return ;
+ 	}
+ 
+ 	if(Channel == 0)
+ 	{
+ 		SelectFirstChannel(BoardID);
+ 	}
+ 	else
+ 	{
+ 		SelectSecondChannel(BoardID);
+ 	}
+ 	pPDTTable = BoardInfo[BoardID].PriScatterList;
+ 	IOPort1 = BoardInfo[BoardID].PrimaryIO;
+ 	DmaIO = BoardInfo[BoardID].PrimaryDmaIO;
+ 	memcpy(pPDTTable,pRWInfo->ScatterList,pRWInfo->ListCount * sizeof(PDT_TABLE));
+ 	BoardInfo[BoardID].ListCount 		= pRWInfo->ListCount;
+ 	BoardInfo[BoardID].NumSectors       = pRWInfo->NumSectors;
+ 	BoardInfo[BoardID].StartLba         = pRWInfo->StartLba;
+ 
+ 	AddressLow = virt_to_bus(pPDTTable) & 0x0000ffff;
+ 	AddressHi = (virt_to_bus(pPDTTable) & 0xffff0000) >> 16;
+ 
+ 	outw(AddressLow,DmaIO + PDTLAR);
+ 	outw(AddressHi,DmaIO + PDTHAR);
+ 
+ 	PutLBAvalue(
+ 			IOPort1,
+ 			BoardInfo[BoardID].StartLba,
+ 			BoardInfo[BoardID].NumSectors,
+ 			Drive);
+ }
+ 
+ void SetIOInformation(int tid,USHORT DmaRW,DWORD OrderFlag)
+ {
+ 	DISKRWINFO 	*pRWInfo = GetRWInfoPointer(&DiskID[tid].DiskStatus);
+ 	if (pRWInfo->ListCount) {
+ 		SetIOPort(&DiskID[tid].DiskStatus,DmaRW,OrderFlag);
+ 	}
+ }
+ 
+ 
+ void SetIDECommand(DWORD Command, DWORD OrderFlag)
+ {
+ 	int i,j;
+ 
+ 	for(i=0;i<MAXBOARD;i++) {
+ 		if (BoardInfo[i].InterruptFlag[0] & OrderFlag) {
+ 			if(BoardInfo[i].StartLba >= 0x10000000)
+ 				Command=BigDiskCommand(Command);
+ 			outb(Command,BoardInfo[i].PrimaryIO + CommandPort);
+ 		}
+ 		/*		
+ 				if (BoardInfo[i].InterruptFlag[1] & OrderFlag) {
+ 				if(BoardInfo[i].StartLba >= 0x10000000)
+ 				Command=BigDiskCommand(Command);
+ 				outb(Command,BoardInfo[i].SecondaryIO + CommandPort);
+ 				}
+ 		 */
+ 	}
+ }
+ 
+ DWORD	BigDiskCommand (DWORD cmnd)
+ {
+ 	switch(cmnd){
+ 		case	IDE_COMMAND_READ_DMA:
+ 			return IDE_COMMAND_READ_DMA_EXT;
+ 		case	IDE_COMMAND_WRITE_DMA:
+ 			return IDE_COMMAND_WRITE_DMA_EXT;
+ 	}
+ // Added 2003/11/09 by Ashuaria Lee
+ #warning I dont know what to do...
+ 	return cmnd;
+ }
+ 
+ void SetDMACommand(USHORT DmaRW,DWORD OrderFlag)
+ {
+ 	ULONG		DmaIO;
+ 	int         i,j,k;
+ 
+ 	for(i=0;i<gBoardCount;i++)
+ 	{
+ 		for(j=0;j<2;j++)
+ 		{
+ 			for(k=0;k<2;k++)
+ 			{
+ 				if ((OrderFlag & DiskRWInfo[i][j][k].InterruptFlag))
+ 				{
+ 					DmaIO = BoardInfo[i].PrimaryDmaIO;
+ 					outw((0xff00 | HddSupportMode[i][j][k]), DmaIO + UDM_TIM);
+ 					outw(1, DmaIO + DMAMODE);		
+ 					outw(DmaRW,DmaIO + CMDR);
+ 				}
+ 			}
+ 		}
+ 	}
+ }
+ 
+ 
+ static int			ReadDMA(
+ 		Scsi_Cmnd * SCpnt,
+ 		ULONG lba,
+ 		ULONG numsectors)
+ {
+ 	int 			i;
+ 	unsigned long	flags;
+ 
+ 	if (numsectors == 0) {
+ 		my_done(DID_ABORT << 16);
+ 		return ERROR_INVALID_SECTORCOUNT;
+ 	}
+ 	SetScatterList(SCpnt,lba,numsectors,READ_STATUS);
+ 	SetIOInformation(SCpnt->target,DMA_READ,ORDER_ONE);
+ 	RWStatus = READ_STATUS;
+ 	OrderStatus = ORDER_ONE;
+ 	SetIDECommand(IDE_COMMAND_READ_DMA,ORDER_ONE);
+ 	SetDMACommand(DMA_READ,ORDER_ONE);
+ 	return 0;	
+ }
+ 
+ static int			WriteDMA(
+ 		Scsi_Cmnd * SCpnt,
+ 		ULONG lba,
+ 		ULONG numsectors)
+ {
+ 	int 		i;
+ 	unsigned long	flags;
+ 
+ 	if (numsectors == 0) {
+ 		my_done(DID_ABORT << 16);
+ 		return ERROR_INVALID_SECTORCOUNT;
+ 	}
+ 	SetScatterList(SCpnt,lba,numsectors,WRITE_STATUS);
+ 	SetIOInformation(SCpnt->target,DMA_WRITE,ORDER_ONE);
+ 	RWStatus = WRITE_STATUS;
+ 	OrderStatus = ORDER_ONE;
+ 
+ 	SetIDECommand(IDE_COMMAND_WRITE_DMA,ORDER_ONE);
+ 	SetDMACommand(DMA_WRITE,ORDER_ONE);
+ 
+ 	return 0;	
+ }
+ 
+ void GetUDMAMode(USHORT *mode,USHORT *Timing,
+ 		IDENTIFY_DATA * IdentifyData)
+ {
+ 
+ 	if(IdentifyData->UDMASupport & 0x40){ 
+ 		*mode = 0x46; // mode 6
+ 		*Timing = 0xff22; // mode 6
+ 	}
+ 	else if(IdentifyData->UDMASupport & 0x20){ 
+ 		*mode = 0x45; // mode 5
+ 		*Timing = 0xff33; // mode 5
+ 	}
+ 	else if(IdentifyData->UDMASupport & 0x10){ 
+ 		*mode = 0x44; // mode 4
+ 		*Timing = 0xff44; // mode 4
+ 	} 
+ 	else if(IdentifyData->UDMASupport & 0x08){ 
+ 		*mode = 0x43; // mode 3
+ 		*Timing = 0xff55; // mode 3
+ 	} 
+ 	else if(IdentifyData->UDMASupport & 0x04){ 
+ 		*mode = 0x42; // mode 2
+ 		*Timing = 0xff66; // mode 2
+ 	} 
+ 	else if(IdentifyData->UDMASupport & 0x02){ 
+ 		*mode = 0x41; // mode 1
+ 		*Timing = 0xff77; // mode 1
+ 	} 
+ 	else if(IdentifyData->UDMASupport & 0x01){ 
+ 		*mode = 0x40; // mode 0
+ 		*Timing = 0xff88; // mode 0
+ 	} 
+ #ifdef _7878_
+ 	*mode = 0x44; // mode 4
+ 	*Timing = 0x7878; // safe mode
+ #endif
+ }
+ 
+ void SetUDMAMode(int BoardID, int Channel, int Drive)
+ {
+ 	USHORT 		mode[3],Timing[3];
+ 	ULONG    	IOPort1;
+ 	ULONG		DmaIO;
+ 	char		statusByte=0;
+ 	int i;	
+ 
+ 	if(Channel == 0)
+ 	{
+ 		SelectFirstChannel(BoardID);
+ 	}
+ 	else
+ 	{
+ 		SelectSecondChannel(BoardID);
+ 	}
+ 	IOPort1 = BoardInfo[BoardID].PrimaryIO;
+ 	DmaIO = BoardInfo[BoardID].PrimaryDmaIO;
+ 	
+ 	
+ 	if(HddConnected[BoardID][Channel][Drive]>0)
+ 	{
+ 		mode[0] = 0xffff;
+ 		Timing[0] = 0xffff;
+ 		GetUDMAMode(&mode[0],&Timing[0],&DiskIdentifyData[BoardID][Channel][Drive]);
+ //		printk("udma mode value = %x\n",mode[0]);
+ 		if(mode[0] == 0xffff)
+ 			return;
+ 		outb(0xA0 + (Drive << 4),IOPort1 + DriveSelectPort);
+ 		for(i=0;i<10000;i++)
+ 		{		
+ 			GetBaseStatus(IOPort1, statusByte);
+ 			udelay(100);	
+ 			if(statusByte & IDE_STATUS_BUSY)
+ 				continue;
+ 			else
+ 				break;	
+ 		}
+ 		outb(0xA0 + (Drive << 4),IOPort1 + DriveSelectPort);
+ 		outb(mode[0],IOPort1 + BlockCountPort);
+ 		outb(0x03,IOPort1 + ErrorPort);
+ 		outb(IDE_COMMAND_ENABLE_MEDIA_STATUS,IOPort1 + CommandPort);
+ 		for(i=0;i<10000;i++)
+ 		{		
+ 			GetBaseStatus(IOPort1, statusByte);
+ 			udelay(100);	
+ 			if(statusByte & IDE_STATUS_BUSY)
+ 				continue;
+ 			else
+ 				break;	
+ 		}
+ 		if(statusByte == 0x50 || statusByte == 0x40)		
+ 		{
+ 			HddSupportMode[BoardID][Channel][Drive] = (((mode[0] << 8) | 0xff) & Timing[0]);
+ //			printk("SetUDMA: SupportMode = %0.4x\n", HddSupportMode[BoardID][Channel][Drive]);
+ 		}
+ 	}
+ 	mdelay(5);
+ 	for(i=0;i<10;i++)
+ 	{
+ 		GetBaseStatus(IOPort1, statusByte);
+ 		if(statusByte & IDE_STATUS_IDLE)
+ 			break;
+ 		else
+ 			mdelay(2);
+ 	}
+ }
+ 
+ static int	IdentifyDisk( 
+ 		int BoardID,
+ 		int Channel, 
+ 		int DriveSelect, 
+ 		IDENTIFY_DATA * IdentifyData)
+ {
+ 	ULONG    	IOPort1,DmaIO,ControlRegister;
+ 	UCHAR   	statusByte;
+ 	USHORT 		*pIdentifyData;
+ 	int             i, j;
+ 	int			flag = 0;
+ 
+ 	if(Channel == 0)
+ 	{
+ 		SelectFirstChannel(BoardID);
+ 	}
+ 	else
+ 	{
+ 		SelectSecondChannel(BoardID);
+ 	}
+ 	IOPort1 = BoardInfo[BoardID].PrimaryIO;
+ 	DmaIO = BoardInfo[BoardID].PrimaryDmaIO;
+ 	ControlRegister = BoardInfo[BoardID].ControlRegister;
+ 	outb(((DriveSelect << 4) | 0xA0), IOPort1 + DriveSelectPort);
+ 
+ 	for (i=0;i<1000;i++)
+ 	{
+ 		udelay(10);
+ 		GetBaseStatus(IOPort1, statusByte);
+ 		if (!(statusByte & 0x80))
+ 			break;
+ 	}
+ 	outb(((DriveSelect << 4) | 0xA0), IOPort1 + DriveSelectPort);
+ 	mdelay(50);
+ 	GetBaseStatus(IOPort1, statusByte);
+ 	outb(((DriveSelect << 4) | 0xA0), IOPort1 + DriveSelectPort);
+ 	mdelay(50);
+ 	GetBaseStatus(IOPort1, statusByte);
+ 	if(statusByte != 0x50)
+ 	{
+ 		outb(0x08, IOPort1 + CommandPort); //Device reset
+ 		for(i=0; i<3; i++)	//	KHG_20020731
+ 		{
+ 			mdelay(100);
+ 			outb(((DriveSelect << 4) | 0xA0), IOPort1 + DriveSelectPort); 
+ 			GetBaseStatus(IOPort1, statusByte);
+ 			if(statusByte != 0x50)
+ 			{
+ 				outb(0x04, IOPort1 + 0x0e);
+ 				mdelay(100);
+ 				outb(0x00, IOPort1 + 0x0e);
+ 			}
+ 			else
+ 			{
+ 				break;
+ 			}
+ 		}
+ 	}
+ 	mdelay(50);
+ 	statusByte = statusByte & 0xc9;
+ 	if (statusByte != IDE_STATUS_DRDY)
+ 	{
+ 		return 0;
+ 	}
+ 
+ 
+ label1:
+ 	for (j = 0; j < 2; j++)
+ 	{
+ 		WaitOnBusy(IOPort1, statusByte);
+ 		outb(IDE_COMMAND_IDENTIFY, IOPort1 + CommandPort);
+ 
+ 		for (i = 0; i < 4; i++)
+ 		{
+ 			WaitForDrq(IOPort1, statusByte);
+ 			if (statusByte & IDE_STATUS_DRQ)
+ 			{
+ 				GetBaseStatus(IOPort1, statusByte);
+ 				break;
+ 			}
+ 			WaitOnBusy(IOPort1, statusByte);
+ 		}
+ 		if (i == 4 && j == 0)
+ 		{
+ 			return 0;
+ 		}
+ 		else
+ 		{
+ 			break;
+ 		}
+ 	}			// end of for (j = 0; j < 2; j++)
+ 
+ 
+ 	if (statusByte & IDE_STATUS_ERROR)
+ 	{
+ 		return 0;
+ 	}
+ 
+ 	WaitOnBusy(IOPort1, statusByte);
+ 
+ 
+ 	if (!(statusByte & IDE_STATUS_DRQ))
+ 	{
+ 		return 0;
+ 	}
+ 
+ 	pIdentifyData = (USHORT *) IdentifyData;
+ 
+ 	outb(((DriveSelect << 4) | 0xA0), IOPort1 + DriveSelectPort);
+ 	mdelay(50);
+ 	GetBaseStatus(IOPort1, statusByte);
+ 	for (i = 0; i < 256; i++)
+ 	{
+ 		pIdentifyData[i] = inw(IOPort1 + DataPort);
+ 	}
+ 	{
+ 		char           *p,c;
+ 		p = (char *) &(IdentifyData->VendorUnique1);
+ 
+ 		for (i = 0; i < 26; i+=2)
+ 		{
+ 			c = p[i];
+ 			p[i] = p[i+1];
+ 			p[i+1] = c;
+ 		}
+ 		p = (char *) &(IdentifyData->ModelNumber);
+ 
+ 		for (i = 0; i < 40; i+=2)
+ 		{
+ 			c = p[i];
+ 			p[i] = p[i+1];
+ 			p[i+1] = c;
+ 		}
+ 	}
+ 
+ 	{
+ 		int mm = 0;
+ 
+ 		for (i = 0; i < 0x1000; i++)
+ 		{
+ 
+ 			GetStatus(IOPort1, statusByte);
+ 
+ 			if ((statusByte & IDE_STATUS_DRQ)
+ 					|| (statusByte & IDE_STATUS_BUSY)
+ 					|| (statusByte & 1) )
+ 			{
+ 				inw(IOPort1 + DataPort);
+ 			}
+ 			else
+ 			{
+ 				break;
+ 			}
+ 		}			// end of for
+ 	}
+ 	return 1;
+ }
+ 
+ char     *ultima_info(struct Scsi_Host *ignore)
+ {
+ 	static char     buffer[128];
+ 	char           *pt;
+ 
+ 	strcpy(buffer, "Aralion Ultima ATA133 IDE RAID MultiCard Driver Version");
+ 	if (strchr(VERSION, ':'))
+ 	{			/* Assume VERSION is an RCS Revision string */
+ 		strcat(buffer, strchr(VERSION, ':') + 1);
+ 		pt = strrchr(buffer, '$') - 1;
+ 		if (!pt)		/* Stripped RCS Revision string? */
+ 			pt = buffer + strlen(buffer) - 1;
+ 		if (*pt != ' ')
+ 			++pt;
+ 		*pt = '\0';
+ 	}
+ 	else
+ 	{			/* Assume VERSION is a number */
+ 		strcat(buffer, " " VERSION);
+ 	}
+ 
+ 	return buffer;
+ }
+ 
+ 
+ int init_module(void) {
+ 	driver_template.module = &__this_module;
+ 	scsi_register_module(MODULE_SCSI_HA, &driver_template);
+ 	if (driver_template.present) {
+ 		return 0;
+ 	}
+ 
+ 	scsi_unregister_module(MODULE_SCSI_HA, &driver_template);
+ 	return -1;
+ }
+ 
+ void cleanup_module( void) {
+ 	scsi_unregister_module(MODULE_SCSI_HA, &driver_template);
+ }
+ 
+ int             ultima_proc_info(char *buffer, char **start, off_t offset,
+ 		int length, int hostno, int inout)
+ {
+ 	const char     *info = ultima_info(NULL);
+ 	int             len;
+ 	int             pos;
+ 	int             begin;
+ 
+ 	if (inout)
+ 		return (-ENOSYS);
+ 
+ 	begin = 0;
+ 	strcpy(buffer, info);
+ 	strcat(buffer, "\n");
+ 
+ 	pos = len = strlen(buffer);
+ 
+ 	if (pos < offset)
+ 	{
+ 		len = 0;
+ 		begin = pos;
+ 	}
+ 
+ 	*start = buffer + (offset - begin);	/* Start of wanted data */
+ 	len -= (offset - begin);
+ 	if (len > length)
+ 		len = length;
+ 
+ 	return (len);
+ }
+ 
+ static int      aralion_arbitrate(void)
+ {
+ 	int             status = 0;
+ 	ULONG   timeout;
+ 
+ 	printk("[ aralion_arbitrate ]\n");
+ 
+ 	return 0;
+ }
+ 
+ static int      aralion_select(int target)
+ {
+ 	int             status;
+ 	ULONG   timeout;
+ 	static int      flag = 0;
+ 
+ 
+ 	printk("[ aralion_select - %d ]\n",target);
+ 	return 0;
+ }
+ 
+ static void            my_done(int error)
+ {
+ 	if (in_command)
+ 	{
+ 		in_command = 0;
+ 		//		printk("my_done\n");
+ 		if (test_and_clear_bit(IOCTL_LOCK,&LockValue) == 0)
+ 			printk("misc clear...\n");
+ 		current_SC->result = error;
+ 		if (current_SC->scsi_done) {
+ 			current_SC->scsi_done(current_SC);
+ 		}
+ 		else
+ 			panic("scsi: <aralion> current_SC->scsi_done() == NULL");
+ 	}
+ 	else
+ 	{
+ 		panic("scsi: <aralion> my_done() called outside of command\n");
+ 	}
+ }
+ 
+ int	CheckScsiError(ULONG Channel,ULONG IOPort1,UCHAR statusByte)
+ {
+ 	ULONG 	lba;
+ 	UCHAR 	Data[4];
+ 	UCHAR	errorByte;
+ 	ULONG 	scsiStatus = 0;
+ 
+ 	if (statusByte & 0x1) {
+ 
+ 		errorByte = inb(IOPort1 + ErrorPort);
+ 		printk("error byte = %x",ErrorPort);
+ 		if (errorByte & IDE_ERROR_BAD_BLOCK)
+ 			scsiStatus = DID_PARITY;
+ 		else if (errorByte & IDE_ERROR_DATA_ERROR)
+ 			scsiStatus = DID_ERROR;
+ 		else if (errorByte & IDE_ERROR_ID_NOT_FOUND)
+ 			scsiStatus = DID_NO_CONNECT;
+ 		else if (errorByte & IDE_ERROR_COMMAND_ABORTED)
+ 			scsiStatus = DID_ABORT;
+ 		else if (errorByte & IDE_ERROR_ILLEGAL_LENGTH )
+ 			scsiStatus = DID_ERROR;
+ 
+ 		Data[3] = inb(IOPort1 + BlockNumberPort);
+ 		Data[2] = inb(IOPort1 + CylinderLowPort);
+ 		Data[1] = inb(IOPort1 + CylinderHighPort);
+ 		Data[0] = inb(IOPort1 + DriveSelectPort) & 0x0f;
+ 
+ 		lba = (Data[0] << 24) + (Data[1] << 16)
+ 			+ (Data[2] << 8) + Data[0];
+ 
+ 		LastErrorBlock = lba;
+ 		LastErrorCode = errorByte & 0x000f;
+ 
+ 		printk("Error! Ch:%d, %02x , %0d\n",Channel,
+ 				(UCHAR) errorByte,lba);
+ 		return scsiStatus;
+ 	}
+ 	else
+ 		return 0;
+ }
+ 
+ void CheckJobFinished(ULONG BoardID,ULONG Channel)
+ {
+ 	ULONG DmaIO;
+ 	USHORT Stat;
+ 	DWORD	i = 0;
+ 
+ 	if (Channel == 1) {
+ 		DmaIO = BoardInfo[BoardID].PrimaryDmaIO;
+ 	}
+ 	else
+ 	{	
+ 		DmaIO = BoardInfo[BoardID].SecondaryDmaIO;
+ 	}
+ 	do {
+ 		Stat = inw(DmaIO + CONSR);
+ 		i++;
+ 	} while ((Stat & 0x01) && (i < 1000));
+ 	if(i>100)
+ 	{
+ 	    printk("CheckJobFinished Error\n");
+ 	}
+ }
+ 
+ void ClearAllIrq(void)
+ {
+ 	ULONG	Channel;
+ 	UCHAR   statusByte = 0;
+ 	UCHAR   statusByte2 = 0;
+ 	ULONG   IOPort1,IOPort2;
+ 	ULONG 	scsiStatus = 0;
+ 	int		i;
+ 
+ 	for(i=0;i<gBoardCount;i++) {
+ 		Channel = inw(BoardInfo[i].ControlRegister + INTSRC) & 0x03;
+ 
+ 		if (Channel == 0) 
+ 			continue;
+ 
+ 		statusByte = statusByte2 = 0;
+ 
+ 		if (Channel != 3 && 
+ 				( (BoardInfo[i].InterruptFlag[0] & OrderStatus) &
+ 				  (BoardInfo[i].InterruptFlag[1] & OrderStatus)
+ 				)
+ 		   )	
+ 			continue;
+ 		if (Channel & 1) {
+ 			IOPort1 = BoardInfo[i].PrimaryIO;
+ 			CheckJobFinished(i,1);
+ 			GetBaseStatus(IOPort1, statusByte);
+ 			BoardInfo[i].InterruptFlag[0] &= (~OrderStatus);
+ 		}
+ 	}
+ }
+ 
+ void            do_ultima_intr(int irq, void *dev_id, struct pt_regs *regs)
+ {
+ 	ULONG	Channel;
+ 	UCHAR   statusByte = 0;
+ 	UCHAR   statusByte2 = 0;
+ 	ULONG   IOPort1,IOPort2;
+ 	ULONG 	scsiStatus = 0;
+ 	IrqID	*pIntID;
+ 	int		i,j,flag;
+ 	int     ClearFlag = 0;
+ 	int		InterruptCount;
+ 	unsigned long flags;
+ 
+ 	spin_lock_irqsave(&io_request_lock, flags);
+ 	pIntID = (IrqID *) dev_id;
+ 
+ 	//	printk("< intr >\n");	
+ 
+ 	if (!pIntID) {
+ 		spin_unlock_irqrestore(&io_request_lock, flags);
+ 		return ;
+ 	}
+ 	/*
+ 	   if (gResetFlag) {
+ 	   for (i=0;i<gBoardCount;i++) {
+ 	   USHORT		Intena;
+ 
+ 	   Channel = inw(BoardInfo[i].ControlRegister + INTSRC);
+ 	   Intena = inw(BoardInfo[i].ControlRegister + INTENA);
+ 	   IOPort1 = BoardInfo[i].PrimaryIO;
+ 	   IOPort2 = BoardInfo[i].SecondaryIO;
+ 	   if (Channel & 1) {
+ 	   CheckJobFinished(i,1);
+ 	   GetBaseStatus(IOPort1, statusByte);
+ 	   }
+ 	   if (Channel & 2) {
+ 	   CheckJobFinished(i,2);
+ 	   GetBaseStatus(IOPort2, statusByte2);
+ 	   }
+ 	   if (statusByte & 0x1) 
+ 	   scsiStatus = CheckScsiError(Channel,IOPort1,statusByte);
+ 
+ 	   if (statusByte2 & 0x1)
+ 	   scsiStatus = CheckScsiError(Channel,IOPort2,statusByte);
+ 	   }
+ 	   spin_unlock_irqrestore(&io_request_lock, flags);
+ 	   return ;
+ 
+ 	   }
+ 	 */
+ 	if (!in_command) {
+ 		ClearAllIrq();
+ 		spin_unlock_irqrestore(&io_request_lock, flags);
+ 		return ;
+ 	}
+ 
+ 	for(i=0;i<gBoardCount;i++) {
+ 		Channel = inw(BoardInfo[i].ControlRegister + INTSRC) & 0x03;
+ 
+ 		if (Channel == 0) 
+ 			continue;
+ 
+ 		flag = 0;
+ 		statusByte = statusByte2 = 0;
+ 
+ 		if (Channel != 3 && 
+ 				( (BoardInfo[i].InterruptFlag[0] & OrderStatus) &
+ 				  (BoardInfo[i].InterruptFlag[1] & OrderStatus)
+ 				)
+ 		   )	
+ 			continue;
+ 		if (Channel & 1) {
+ 			IOPort1 = BoardInfo[i].PrimaryIO;
+ 			CheckJobFinished(i,1);
+ 			GetBaseStatus(IOPort1, statusByte);
+ 			BoardInfo[i].InterruptFlag[0] &= (~OrderStatus);
+ 		}
+ 		if (Channel & 2) {
+ 			IOPort2 = BoardInfo[i].SecondaryIO;
+ 			CheckJobFinished(i,2);
+ 			GetBaseStatus(IOPort2, statusByte2);
+ 			BoardInfo[i].InterruptFlag[1] &= (~OrderStatus);
+ 		}
+ 		if (statusByte & 0x1) 
+ 			scsiStatus = CheckScsiError(Channel,IOPort1,statusByte);
+ 
+ 		if (statusByte2 & 0x1) 
+ 			scsiStatus = CheckScsiError(Channel,IOPort2,statusByte2);
+ 	}
+ 	if (OrderStatus != ORDER_FOUR) {
+ 		for(i=0;i<gBoardCount;i++) {
+ 			if (BoardInfo[i].InterruptFlag[0] & OrderStatus || BoardInfo[i].InterruptFlag[1] & OrderStatus) {
+ 				spin_unlock_irqrestore(&io_request_lock, flags);
+ 				return ;
+ 			}
+ 		}	
+ 		flag = 0;
+ 
+ 		for(i=0;i<gBoardCount;i++) {
+ 			if ((BoardInfo[i].InterruptFlag[0] & ORDER_TWO || BoardInfo[i].InterruptFlag[1] & ORDER_TWO) && (OrderStatus == ORDER_ONE)) {
+ 				flag = 1;
+ 			}
+ 			if ((BoardInfo[i].InterruptFlag[0] & ORDER_THREE || BoardInfo[i].InterruptFlag[1] & ORDER_THREE) && (OrderStatus == ORDER_TWO)) {
+ 				flag = 1;
+ 			}
+ 			if ((BoardInfo[i].InterruptFlag[0] & ORDER_FOUR || BoardInfo[i].InterruptFlag[1] & ORDER_FOUR) && (OrderStatus == ORDER_THREE)) {
+ 				flag = 1;
+ 			}
+ 		}	
+ 
+ 		if (flag) {
+ 			OrderStatus <<= 4;
+ 
+ 			if (RWStatus == READ_STATUS) {
+ 				SetIOInformation(CurrentDisk,DMA_READ,OrderStatus);
+ 				SetIDECommand(IDE_COMMAND_READ_DMA,OrderStatus);
+ 				SetDMACommand(DMA_READ,OrderStatus);
+ 			}
+ 			else {
+ 				SetIOInformation(CurrentDisk,DMA_WRITE,OrderStatus);
+ 				SetIDECommand(IDE_COMMAND_WRITE_DMA,OrderStatus);
+ 				SetDMACommand(DMA_WRITE,OrderStatus);
+ 			}
+ 			spin_unlock_irqrestore(&io_request_lock, flags);
+ 			return ;
+ 		}
+ 		else {
+ 
+ 			my_done(scsiStatus << 16);
+ 			spin_unlock_irqrestore(&io_request_lock, flags);
+ 			return ;
+ 		}
+ 	}
+ 	else {
+ 		for(i=0;i<gBoardCount;i++) {
+ 			if (BoardInfo[i].InterruptFlag[0] & ORDER_FOUR || BoardInfo[i].InterruptFlag[1] & ORDER_FOUR) {
+ 				spin_unlock_irqrestore(&io_request_lock, flags);
+ 				return ;
+ 			}
+ 		}	
+ 	}
+ 	my_done(scsiStatus << 16);
+ 	spin_unlock_irqrestore(&io_request_lock, flags);
+ 
+ 	return;
+ }
+ 
+ void     internal_done(Scsi_Cmnd * SCpnt)
+ {
+ 	internal_done_errcode = SCpnt->result;
+ 	++internal_done_flag;
+ }
+ 
+ int IsSplitter(char c)
+ {
+ 	if (c == ' ' || c == '-' || c == '_')
+ 		return 1;
+ 	else if (c >= '0' && c <= '9')
+ 		return 1;
+ 
+ 	return 0;
+ }
+ 
+ int             ultima_queue(Scsi_Cmnd * SCpnt, void (*done) (Scsi_Cmnd *))
+ {
+ 	char 			*buf;
+ 	int	 			board,channel,drive;
+ 	ULONG			result;
+ 	/*
+ 	   printk("[c=%x : %s,I=%x]\n",
+ 	   (UCHAR) SCpnt->cmnd[0],
+ 	   GetCmdName((UCHAR) SCpnt->cmnd[0]),
+ 	   SCpnt->target);
+ 	 */
+ 	if (in_command) {
+ 		printk("[ ultima_queue c=%x : %s,I=%x]\n",
+ 				(UCHAR) SCpnt->cmnd[0],
+ 				GetCmdName((UCHAR) SCpnt->cmnd[0]),
+ 				SCpnt->target);
+ 		panic("Error! in_command == 1\n");
+ // Added 2003/11/09 by Ashuaria Lee
+ #warning I dont know what to do...
+ 		return -1;
+ 	}
+ 	while(test_and_set_bit(IOCTL_LOCK,&LockValue) != 0) {
+ 		//		printk("QW ");
+ 		schedule();
+ 		udelay(1);
+ 	}
+ 	while(in_ioctl) {
+ 		printk("in_ioctl = 1\n");
+ 		udelay(1);
+ 	}
+ 	in_command = 1;
+ 	current_SC = SCpnt;
+ 	current_SC->scsi_done = done;
+ 
+ 	current_SC->SCp.Status              = 0;
+ 	current_SC->SCp.Message             = 0;
+ 	current_SC->SCp.have_data_in        = 0;
+ 	current_SC->SCp.sent_command        = 0;
+ 	current_SC->SCp.phase               = in_arbitration;
+ 
+ 	if (SCpnt->target >= DiskCount || SCpnt->lun > 0) {
+ 		my_done(DID_ABORT << 16);
+ 		return 0;
+ 	}
+ 
+ 	if (SCpnt->target >= DiskCount) {
+ 		my_done(DID_ABORT << 16);
+ 		return 0;
+ 	}
+ 
+ 	board = DiskID[current_SC->target].DiskStatus.BoardID;
+ 	channel = DiskID[current_SC->target].DiskStatus.Channel;
+ 	drive = DiskID[current_SC->target].DiskStatus.Drive;
+ 	switch(current_SC->cmnd[0]) {
+ 		case TEST_UNIT_READY:
+ 		case REQUEST_SENSE :
+ 			my_done(0);
+ 			return 0;
+ 
+ 		case MODE_SENSE :
+ 			buf = (char *) current_SC->buffer;
+ 			buf[2] = 0x0;
+ 			my_done(0);
+ 			break;
+ 
+ 		case INQUIRY :
+ 			buf = (char *) current_SC->buffer;
+ 			{
+ 				PINQUIRYDATA    inquiryData
+ 					= (PINQUIRYDATA) current_SC->buffer;
+ 				PIDENTIFY_DATA identifyData =
+ 					&DiskIdentifyData[board][channel][drive];
+ 				int i;
+ 
+ 				memset(buf,0,current_SC->bufflen);
+ 
+ 				buf[4] = sizeof(INQUIRYDATA);
+ 
+ 				//
+ 				// Standard IDE interface only supports disks.
+ 				inquiryData->DeviceType = DIRECT_ACCESS_DEVICE;
+ 
+ 				//
+ 				// Fill in vendor identification fields.
+ 				{
+ 					unsigned char *p;
+ 					int	i,j;
+ 
+ 					for (i = 0; i < 24; i ++) {  
+ 						inquiryData->VendorId[i] = 0;
+ 					}
+ 					p = (UCHAR *) identifyData->ModelNumber;
+ 					i = 0;
+ 
+ 					while(!IsSplitter(p[i])) {
+ 						inquiryData->VendorId[i] = p[i++];
+ 					}
+ 					inquiryData->VendorId[i] = 0;
+ 
+ 					i++;
+ 					j = 0;
+ 					while (p[i] != ' ' && i < 24) 
+ 						inquiryData->ProductId[j++] = p[i++];
+ 					inquiryData->ProductId[j] = 0;
+ 
+ 				}
+ 				//
+ 				// Initialize unused portion of product id.
+ 				for (i = 0; i < 4; i++) {
+ 					inquiryData->ProductId[12+i] = ' ';
+ 				}
+ 
+ 				//
+ 				// Move firmware revision from IDENTIFY data to
+ 				// product revision in INQUIRY data.
+ 				for (i = 0; i < 4; i += 2) {
+ 					inquiryData->ProductRevisionLevel[i] =
+ 						((UCHAR *)identifyData->FirmwareRevision)[i+1];
+ 					inquiryData->ProductRevisionLevel[i+1] =
+ 						((UCHAR *)identifyData->FirmwareRevision)[i];
+ 				}
+ 			}
+ 			//					printk("Inquiry Success!");
+ 			my_done(0);
+ 			break;
+ 		case READ_6 : 
+ 		case READ_10 :
+ 		case WRITE_6 : 	
+ 		case WRITE_10 :
+ 			{
+ 				ULONG numsectors,lba,i ;
+ 
+ 				if (*current_SC->cmnd == READ_6 || *current_SC->cmnd == WRITE_6) {
+ 					numsectors = (u_long) current_SC->cmnd[4];
+ 					lba = ((u_long) current_SC->cmnd[1] << 16) |
+ 						((u_long) current_SC->cmnd[2] << 8) |
+ 						(u_long) current_SC->cmnd[3];
+ 					lba &= 0x1FFFFF;
+ 				}
+ 				if (*current_SC->cmnd == READ_10 || *current_SC->cmnd == WRITE_10) {
+ 					numsectors = (u_long) current_SC->cmnd[8] |
+ 						((u_long) current_SC->cmnd[7] << 8);
+ 					lba = ((u_long) current_SC->cmnd[2] << 24) |
+ 						((u_long) current_SC->cmnd[3] << 16) |
+ 						((u_long) current_SC->cmnd[4] << 8) |
+ 						(u_long) current_SC->cmnd[5];
+ 				}
+ 
+ 				memset(DiskRWInfo,0,sizeof(DiskRWInfo));
+ 				for(i=0;i<gBoardCount;i++) {
+ 					BoardInfo[i].InterruptFlag[0] = 0;
+ 					BoardInfo[i].InterruptFlag[1] = 0;
+ 				}
+ 				CurrentDisk = current_SC->target;
+ 
+ 				if (*current_SC->cmnd == READ_6 || *current_SC->cmnd == READ_10) {
+ 
+ //					printk("R:[%03d,%08x]\n", numsectors,lba);
+ 					ReadDMA(current_SC,lba,numsectors);
+ 				}
+ 				else {
+ //					printk("W:[%03d,%08x]\n", numsectors,lba);
+ 					WriteDMA(current_SC,lba,numsectors);
+ 				}
+ 			}	
+ 			break;
+ 
+ 		case READ_CAPACITY :
+ 			{
+ 				ULONG block,size;
+ 				IDENTIFY_DATA * IdentifyData;
+ 
+ 				block = DiskID[current_SC->target].DiskStatus.Size;
+ 				buf = (char *) current_SC->buffer;
+ 				size = 512; 
+ 
+ 				*((ULONG *) buf)  = htonl(block - 1);
+ 				*((ULONG *) (buf + 4))  = htonl(size);
+ 			}
+ 
+ 			my_done(0);
+ 			break;
+ 		default:
+ 			my_done(0);
+ 			break;
+ 
+ 	}
+ 	return 0;
+ }
+ 
+ int             ultima_command(Scsi_Cmnd * SCpnt)
+ {
+ 	ultima_queue(SCpnt, internal_done);
+ 	while (!internal_done_flag)
+ 		;
+ 	internal_done_flag = 0;
+ 	return internal_done_errcode;
+ }
+ 
+ 
+ void            print_info(Scsi_Cmnd * SCpnt)
+ {
+ 	ULONG    imr;
+ 	ULONG    irr;
+ 	ULONG    isr;
+ 
+ 
+ 	if (!SCpnt || !SCpnt->host)
+ 	{
+ 		printk("scsi: <aralion> Cannot provide detailed information\n");
+ 		return;
+ 	}
+ 
+ 	printk("%s\n", ultima_info(SCpnt->host));
+ 	return ;
+ 	print_banner(SCpnt->host);
+ 
+ 	printk("(%d), target = %d cmnd = 0x%02x pieces = %d size = %u\n",
+ 			SCpnt->SCp.phase,
+ 			SCpnt->target,
+ 			*(UCHAR *) SCpnt->cmnd,
+ 			SCpnt->use_sg, SCpnt->request_bufflen);
+ 	printk("sent_command = %d, have_data_in = %d, timeout = %d\n",
+ 			SCpnt->SCp.sent_command,
+ 			SCpnt->SCp.have_data_in, SCpnt->timeout);
+ }
+ 
+ int             ultima_handle(Scsi_Cmnd * SCpnt)
+ {
+ // Added 2003/11/09 by Ashuaria Lee
+ #warning I dont know what to do...
+     return 0;
+ }
+ 
+ int             ultima_abort(Scsi_Cmnd * SCpnt)
+ {
+ 	ULONG   flags;
+ 
+ 	if (!in_command)
+ 	{
+ 		return SCSI_ABORT_NOT_RUNNING;
+ 	}
+ 	ultima_cardreset();
+ 	print_info(SCpnt);
+ 	current_SC->SCp.phase |= aborted;
+ 	current_SC->result = DID_ABORT << 16;
+ 
+ 	/* Aborts are not done well. . . */
+ 	if (in_command)
+ 		my_done(DID_ABORT << 16);
+ 
+ 	return SCSI_ABORT_SUCCESS;
+ }
+ 
+ int             ultima_reset(Scsi_Cmnd * SCpnt, unsigned int ignored)
+ {
+ 	ultima_cardreset();
+ 	return SCSI_RESET_WAKEUP;
+ }
+ 
+ int             ultima_1cardreset(int BoardID)
+ {
+ 	int		i,k;
+ 	UCHAR	statusByte,statusByte2;
+ 
+ 
+ 	SelectFirstChannel(BoardID);	
+ 	mdelay(20);
+ 	outw(0x8000,BoardInfo[BoardID].PrimaryDmaIO + 0x0e);
+ 	mdelay(20);
+ 	outw(0x4000,BoardInfo[BoardID].PrimaryDmaIO + 0x0e);
+ 	mdelay(20);
+ 	outw(0x0,BoardInfo[BoardID].PrimaryDmaIO + 0x0e);
+ 	mdelay(20);
+ 
+ 	SelectSecondChannel(BoardID);
+ 	outw(0x8000,BoardInfo[BoardID].PrimaryDmaIO + 0x0e);
+ 	mdelay(20);
+ 	outw(0x4000,BoardInfo[BoardID].PrimaryDmaIO + 0x0e);
+ 	mdelay(20);
+ 	outw(0x0,BoardInfo[BoardID].PrimaryDmaIO + 0x0e);
+ 	mdelay(20);
+ 	/*
+ 	   for (i=0;i<200;i++) 
+ 	   {
+ 	   SelectFirstChannel(BoardID);	
+ 	   mdelay(1);
+ 	   outb(0xA0, BoardInfo[BoardID].PrimaryIO + DriveSelectPort);
+ 	   mdelay(5);
+ 	   GetBaseStatus(BoardInfo[BoardID].PrimaryIO, statusByte);
+ 	   mdelay(5);
+ 
+ 	   SelectSecondChannel(BoardID);
+ 	   mdelay(1);
+ 	   outb(0xA0, BoardInfo[BoardID].PrimaryIO + DriveSelectPort);
+ 	   mdelay(5);
+ 	   GetBaseStatus(BoardInfo[BoardID].PrimaryIO, statusByte2);
+ 	   mdelay(5);
+ 
+ 	   if (!(statusByte & 0x80) && !(statusByte2 & 0x80))
+ 	   break;
+ 	   }
+ 
+ 	   for (i=0;i<500;i++) {
+ 	   mdelay(1);
+ 	   }
+ 	 */
+ 	for (i=0;i<200;i++) {
+ 		mdelay(20);
+ 	}
+ /*
+ 	if (HddConnected[BoardID][0][0]) 
+ 	{
+ 		IdentifyDisk(BoardID,
+ 				0,
+ 				0,
+ 				&DiskIdentifyData[BoardID][0][0]);
+ 	}
+ 	if (HddConnected[BoardID][0][1]) 
+ 	{
+ 		IdentifyDisk(BoardID,
+ 				0,
+ 				1,
+ 				&DiskIdentifyData[BoardID][0][1]);
+ 	}
+ 	if (HddConnected[BoardID][1][0]) 
+ 	{
+ 		IdentifyDisk(BoardID,
+ 				1,
+ 				0,
+ 				&DiskIdentifyData[BoardID][1][0]);
+ 	}
+ 	if (HddConnected[BoardID][1][1]) 
+ 	{
+ 		IdentifyDisk(BoardID,
+ 				1,
+ 				1,
+ 				&DiskIdentifyData[BoardID][1][1]);
+ 	}
+ */
+ // Added 2003/11/09 by Ashuaria Lee
+ #warning I dont know what to do...
+     return 0;
+ }
+ 
+ 
+ int             ultima_cardreset(void)
+ {
+ 	int		i,j;
+ 
+ 	RWStatus = RESET_STATUS;
+ 
+ 	for(i=0;i<gBoardCount;i++)
+ 	{
+ 		DisableInterrupt(i);
+ 		ultima_1cardreset(i);
+ 		for(j=0;j<4;j++)
+ 		{
+ 			if(HddConnected[i][j/2][j%2]) 
+ 			{
+ 				IdentifyDisk(i,j/2,j%2,&DiskIdentifyData[i][j/2][j%2]);
+ 				SetUDMAMode(i,j/2,j%2);
+ 			}
+ 		}
+ 		EnableInterrupt(i);
+ 	}
+ 	return SCSI_RESET_WAKEUP;
+ }
+ 
+ 
+ int             ultima_biosparam(Scsi_Disk * disk, kdev_t dev,
+ 		int *info_array)
+ {
+ 	int				size;
+ 	int				target;
+ 
+ 	if (MAJOR(dev) != SCSI_DISK0_MAJOR)
+ 	{
+ 		printk("scsi: aralion ultima_biosparam: too many disks");
+ 		return 0;
+ 	}
+ 
+ 	target = MINOR(dev) >> 4;
+ 
+ 	info_array[0] = 16;
+ 	info_array[1] = 63;
+ 
+ 	size = DiskID[target].DiskStatus.Size;
+ 	info_array[2] = size / (info_array[0] * info_array[1]);
+ 
+ 	if (info_array[2] > 1024) { 
+ 		info_array[0] = 0xff;
+ 		info_array[2] =
+ 			(ULONG) size / (info_array[0] * info_array[1]);
+ 	}
+ 	return 0;
+ }
